#!/bin/sh
#
# Component: cases
#
# Description:
#
# OBSOLETE [7.0]
#
#  Commits the storing of a DICOM object on child server.
#
# Usage:
#   commitChild.sh -f <object> -s <study> -H <hostID> [|-h <host>]
#
#     <object>     : Filename of the Dicom Object
#     <study>      : Study Instance UID of the study where the object belongs
#     <hostID>     : Device ID of the child server
#     <host>       : IP Address of the child server (obsolete)
#
# Last Updated     : $Author$
# Update Date Time : $Date$
# RCS File Name    : $RCSfile$
# RCS Revision     : $Revision$
# Locked by        : $Locker$
# Symbolic name    : $Name$
# State            : $State$
#

. $HOME/etc/setenv.sh


# if commitChild.sh is called directly:
# run as a task instead
if [ `basename $0` = "commitChild.sh" ] ; then
	$TASKD_HOME/runshellcmd.sh -R -r 0 $0 "$@"
	exit $?
fi

LOGGER="/usr/bin/logger"
TAG="commitChild.sh[$$]"

INPUT_PARAMS=""
File=""
Study=""
HostIP=""
HostID=""
ErrMsg=""

while getopts 'f:s:h:H:' OPT; do
	case $OPT in
		f) File="$OPTARG" ; INPUT_PARAMS="$INPUT_PARAMS -f \"$OPTARG\""  ;;
		s) Study="$OPTARG" ; INPUT_PARAMS="$INPUT_PARAMS -s \"$OPTARG\""  ;;
		h) HostIP="$OPTARG" ; INPUT_PARAMS="$INPUT_PARAMS -h \"$OPTARG\""  ;;
		H) HostID="$OPTARG" ; INPUT_PARAMS="$INPUT_PARAMS -H \"$OPTARG\""  ;;
		*) ErrMsg="Invalid_Parameter:$OPT" ;;
	esac
done

# DevID is used for logging :: it's either a host ID or an IP address
DevID=$HostID
[ -z "$DevID" ] && DevID="$HostIP"

# include nettask.shi for checking if the device is temporary down
. $TASKD_HOME/nettask.shi

# override getPeer_() of nettask.shi
getPeer_()
{
	echo "$DevID"
}


run_() # override run_ method
{
	[ -z "$File" ] && return 125
	[ -z "$Study" ] && return 125
	[ -z "$DevID" ] && return 125
	[ -n "$ErrMsg" ] && return 125

	$TASKD_HOME/runjavacmd -c "0 cases.CommitChild $INPUT_PARAMS" -p "$JAVA_SERVER_PORT"
	ERR=$?

	exit $ERR

}

# override print_
print_()
{
	$TASKD_HOME/runjavacmd -c "print cases.CommitChild $INPUT_PARAMS" -p "$JAVA_SERVER_PORT"
}
