<%--
 * Component: cases
 *
 * Description:
 *  This page allows the support users to remove a non-final addendum.
 *
 * Parameters:
 *
 *   cSOPIUID          SOPIUID of the final interpretation in question
 *             OR
 *   cStudy            STUDYIUID of the final interpretation in question
 *   cFile             filename of the interpretation
 *   cIntID            InterpretationID of the interpretation
 *   cReason           a non-empty reason must be given to explain the action
 *
 * Last Updated     : $Author$
 * Update Date Time : $Date$
 * RCS File Name    : $RCSfile$
 * RCS Revision     : $Revision$
 * Locked by        : $Locker$
 * Symbolic name    : $Name$
 * State            : $State$
 *
--%><%@page import="com.erad.pacs.modules.gwt.session.right.PacsRight"%>
<%@page import="com.erad.pacs.connector.Connector"%>
<%@page import="com.erad.pacs.services.usermanager.client.Session"%>
<%@page import="com.erad.pacs.services.usermanager.client.interfaces.UserManagerFacade"%>
<%@page import="imagemed.jsputil.MessageBoxHelper"%>
<%@
	page import="java.util.*, java.sql.*, java.io.IOException, java.text.Format,
			imagemed.imsession.*, imagemed.util.*, imagemed.exception.*, imagemed.dcprocessing.StudyRemover"

%><%@
	page errorPage ="../main/exceptionHandler.jsp"

%><%!

	void printResult( Session sess, HttpServletResponse response, String result, boolean isProxy, String backUrl ) throws IMException, IOException {
		response.setHeader( "deleteAddendum", result );
		if ( isProxy ) {
			response.getWriter().println( "OK" );
			return;
		}

		if ( !"SUCCEEDED".equals( result ) ) {
			throw new IMGeneralException( sess, LocalizedMessage.getSimpleMessage( "DELETE_ADDENDUM_FAILED" ), "cases/index.jsp", LocalizedMessage.getSimpleMessage( "DELETE_ADDENDUM_ERROR_TITLE" ), backUrl, 4 );
		}
		
		MessageBox mb = new MessageBox( LocalizedMessage.getSimpleMessage( "DELETE_ADDENDUM_TITLE" ), "60%" );
		mb.setMessage( LocalizedMessage.getSimpleMessage( "DELETE_ADDENDUM_OK" ) );
	
		MessageBoxHelper.showMessageBox(
			new IMMessageBoxException( sess, mb, "cases/index.jsp", 4, backUrl ),
			response.getWriter(),
			sess
		);
	}


%><%
	UserManagerFacade userManager = Connector.getInstance().get( UserManagerFacade.Caller );
	Session sess = userManager.getSessitaSession( request, response );

	String parBack = request.getParameter( "cBack" );
	if ( parBack == null  )
		parBack = request.getHeader( "REFERER" );

	boolean isProxy = "true".equals( request.getParameter( "cProxy" ) );

	if ( !sess.getRights().hasAnyOf( PacsRight.Support, PacsRight.Admin ) ) {
		throw new IMGeneralException( sess, "DELETE_ADDENDUM_NO_RIGHTS", "cases/index.jsp", "DELETE_ADDENDUM_ERROR_TITLE", parBack );
	}

	if ( request.getParameter( "cSOPIUID" ) == null ) {
		// confirmed, do the stuff
		String study = request.getParameter( "cStudy" );
		String fileName = request.getParameter( "cFile" );
		String intID = request.getParameter( "cIntID" );
		String result = "FAILED";
		if ( study == null || study.length() == 0 || fileName == null || fileName.length() == 0 || intID == null || intID.length() == 0 ) {
			Helper.ERRORLOG( "deleteAddendum.jsp", "missing parameter: study=" + study + ", fileName=" + fileName + ", intID=" + intID );
			printResult( sess, response, result, isProxy, parBack );
			return;
		}

		try {
			String proxyID = imagemed.dotcom.Dotcom.getProxyID( study, false );
			if ( proxyID != null ) {
				// do the redirection
				StringBuilder postData = new StringBuilder( 256 );
				postData.append( "cStudy=" ).append( Helper.URLEncodeUTF8( study ) );
				postData.append( "&cFile=" ).append( Helper.URLEncodeUTF8( fileName ) );
			 	postData.append( "&cIntID=" ).append( Helper.URLEncodeUTF8( intID ) );
				postData.append( "&cProxy=true" );
				postData.append( "&ParentSession=" ).append( sess.getSessionId() ); // DOTCOM

				Properties rspHeaders = new Properties();
				if ( Proxy.issueAndCheckProxyURL( sess, proxyID, "/cases/deleteAddendum.jsp", postData.toString(), rspHeaders)) {
					result = rspHeaders.getProperty( "deleteAddendum" );
				}
			}
			else {
				Vector<String> srFiles = new Vector<String>();
				srFiles.add( fileName );
				if ( StudyRemover.removeFiles( sess, null, study, null, sess.getUser().getUserId(), srFiles ) ) {
					result = "SUCCEEDED";
				}
				else {
					Helper.ERRORLOG( "deleteAddendum.jsp", "Deleting " + study + "/" + fileName + " failed" );
				}
			}
		}
		catch ( Throwable th ) {
			Helper.ERRORLOG( "deleteAddendum.jsp", Helper.throwable2String( th ) );
		}

		printResult( sess, response, result, isProxy, parBack );
		return;
	}

	
	if ( !isProxy ) {%><HTML><HEAD><TITLE><%= LocalizedMessage.getSimpleMessage( "DELETE_ADDENDUM_TITLE" )%></TITLE><%
		com.erad.pacs.app.broker.table.internals.TableImpl.printCommonScript( response.getWriter() ); 
%></head><body><%
	}


	String sopiuid = request.getParameter("cSOPIUID");
	String study = null;
	String fileName = null;
	String intID = null;
	ResultSet rs = IMEnv.getDB().createStatement().executeQuery( "select SRCSTUDY, FNAME, INTID from " + IMEnvBase.getEnv( "REPORTTBL" ) +
			" natural join " + IMEnvBase.getEnv( "OBJECTTBL" ) + " where INTSOPIUID='" + sopiuid + "'" );
	if (rs.first()) {
		study = rs.getString("SRCSTUDY");
		fileName = rs.getString("FNAME");
		intID = rs.getString("INTID");
	}
	else {
		//throw new RuntimeException( "The sopiuid " + sopiuid + " seems to be illegal." );
		throw new RuntimeException( LocalizedMessage.getCompoundMessage( "DELETE_ADDENDUM_ILLEGAL_SOPIUID", new Format[] { null }, new Object[] { sopiuid }, true ) );
	}

 	out.println( "<FORM NAME=\"delAddendumForm\" METHOD=\"POST\" ACTION=\"/cases/deleteAddendum.jsp\">" );
 	out.println( "<input type=hidden name=\"cStudy\" value=\"" + study + "\">" );
 	out.println( "<input type=hidden name=\"cFile\" value=\"" + fileName + "\">" );
 	out.println( "<input type=hidden name=\"cIntID\" value=\"" + intID + "\">" );
 	out.println( "<input type=hidden name=\"cBack\" value=\"" + Helper.htmlEncode( parBack ) + "\">" );
	String refererHost = request.getParameter( "RefererHost" );
	if ( refererHost != null ) {
		out.println( "<input type=hidden name=\"RefererHost\" value=\"" + Helper.htmlEncode( refererHost ) + "\">" );
	}
 	
 	out.println( "</FORM>" );
		
	MessageBox mb = new MessageBox( LocalizedMessage.getSimpleMessage( "DELETE_ADDENDUM_TITLE" ), "75%" );
	mb.setMessage( LocalizedMessage.getSimpleMessage( "DELETE_ADDENDUM_CONFIRMATION" ) );
	
	Button continueButton = new Button( "javascript:self.document.delAddendumForm.submit();", "BUTTON_CONTINUE", "ALT_TEXT_CONTINUE" );
	Button cancelButton = new Button( parBack, "BUTTON_CANCEL", "ALT_TEXT_CANCEL" );
	
	mb.addButton( continueButton );
	mb.addButton( cancelButton );

	out.println( "<center>" );
	out.println( "<br>" );
	mb.print( response.getWriter() );
	out.println( "</center>" );

%>
</body>
</html>
