<%@page import="java.nio.file.StandardCopyOption"%>
<%@page import="java.util.List"%>
<%@page import="java.util.ArrayList"%>
<%@page import="java.util.Enumeration"%>
<%@page import="java.nio.file.Files"%>
<%@page import="java.nio.file.Paths"%>
<%@page import="java.nio.file.Path"%>
<%@page import="com.erad.pacs.connector.Connector"%>
<%@page import="com.erad.pacs.services.usermanager.client.Session"%>
<%@page import="com.erad.pacs.services.usermanager.client.interfaces.UserManagerFacade"%>
<%@page import="imagemed.dotcom.DotcomConfig"%>
<%--
* Component: cases
*
* Description:
*  Interface for uploading a study (to the given HUB), extracting it and importing to the worklist
*
* Parameters (multipart):
*
*   cFile         The content of the new DICOM object
*
* Last Updated     : $Author$
* Update Date Time : $Date$
* RCS File Name    : $RCSfile$
* RCS Revision     : $Revision$
* Locked by        : $Locker$
* Symbolic name    : $Name$
* State            : $State$
*
--%><%@
	page import="imagemed.util.*,imagemed.imsession.*,imagemed.jsputil.*,java.io.*,imagemed.types.flag.IMTypeur"

%><%@
	page errorPage ="../main/exceptionHandler.jsp"

%><%
	UserManagerFacade userManager = Connector.getInstance().get( UserManagerFacade.Caller );
	Session sess = userManager.getSessitaSession( request, response );

	Helper.DEBUG( "BUU uploadImportStudy jsp called" );
	
	MultipartRequest mp = new MultipartRequest(request, IMEnvBase.getEnv("TMP"));

	String[] parStudyUIDs = mp.getParameterValues("cGr"); 
	String targetHUB     = mp.getParameter("cTargetHUB");

	//ez itten azt jelenti, hogy minden serverre el fogja kuldeni a multipart-ot, de ezzel nem tudunk mit tenni...
	// majd a feltolto egybol oda kuldi, ha tudja...
	
	Helper.DEBUG( "BUU uploadImportStudy after Multipart request, targetHUB:" + targetHUB + "; session ID: " + sess.getSessionId() + "; userid: " + sess.getUser().getUserId() + "; studies: " + Helper.toString( parStudyUIDs ) );

	if( targetHUB != null && !"".equals( targetHUB ) && !targetHUB.equals( DotcomConfig.selfId() ) ) {
		//redirect, multi params are not needed, they will be included in writeMultipartBodyTo
		String device = DotcomConfig.getConfig().getServerNameTowards( targetHUB );
		if( device != null ) {
			String idBase = RedirectToolbox.getURL( device, sess.getClientAddress().getHostAddress(), null );
			if( idBase != null && !"".equals( idBase ) ) {
				StringBuilder sb = new StringBuilder( idBase );
				sb.append( "/cases/uploadImportStudy.jsp" );
				Helper.DEBUG( "uploadImportStudy redirected to:" + sb.toString() );
				response.sendRedirect( sb.toString() );
				return;
			}
		}
	}

	
	if (!mp.isMultiPart()) {
		Helper.DEBUG( "Not Multipart request" );
		out.print( "FAILED" );
		return;
	}
	else {
		String tmpDirName = IMEnvBase.getEnv( "TMP" ) + "/importstudies." + System.currentTimeMillis();

		try {
			Path dirPathObj = Paths.get( tmpDirName );
			Files.createDirectories( dirPathObj );
//			Helper.extractFilesFromZip( parFile, tmpDirName, false );

			// move files into its original subdir on its original name for the DICOMDIR (also changing \ to /)
			// DICOMDIR is also included in the files
			Enumeration<String> parNames = mp.getParameterNames();
			while( parNames.hasMoreElements() ) {
				String par = parNames.nextElement();
				Helper.DEBUG( "parametername: " + par + " value:" + mp.getParameter( par ) );
				if( par.startsWith( "cFile" ) ) {
					String fileName = mp.getParameter( par );  // saved file name
					String origName = mp.getFileNameFor( par );
					Helper.DEBUG( "filename: " + fileName + " origname: " + origName );
					if( fileName != null && origName != null ) {
						origName = origName.replace( '\\', '/' );
						int lastDirPos = origName.lastIndexOf( '/' );
						if( lastDirPos != -1 ) {
							String actDirName = tmpDirName + "/" + origName.substring( 0, lastDirPos );
							Helper.DEBUG( "actDirName: " + actDirName );
							Path dirPathObjAct = Paths.get( actDirName );
							Files.createDirectories( dirPathObjAct );
						}
						Path src = Paths.get( fileName ); // fileName is the absolute path.
						Path dst = Paths.get( tmpDirName + "/" + origName );
						Files.move( src, dst, StandardCopyOption.ATOMIC_MOVE );
						Helper.DEBUG( "file moved from " + fileName + " to " + tmpDirName + "/" + origName );
					}
				}
			}
			
			
			
			DicomDirToolbox.startImporting( sess, parStudyUIDs, tmpDirName, true ); 
			
//			Helper.removeDirectoryRecursively( tmpDirName );
			out.print( "OK" );
			Helper.DEBUG( "return value:'OK'" );
		}
		catch( Throwable th ) {
			Helper.ERRORLOG( "Exception in media import extracting (to " + tmpDirName + ") :" + Helper.throwable2String( th ) );
			out.print( "FAILED" );
		}

		
		return;
	}
%>