#!/bin/sh
#
# Component:
#
# Description:
#
# Usage:
#
# Last Updated     : $Author: tnemeth $
# Update Date Time : $Date: 2014/04/28 13:08:42 $
# RCS File Name    : $RCSfile: updateSqlTables.sh,v $
# RCS Revision     : $Revision: 1.10 $
# Locked by        : $Locker:  $
# Symbolic name    : $Name:  $
# State            : $State: Exp $
#

. $HOME/etc/setenv.sh

SQLDIR=`dirname $0`/sql

run_query_()
{
	echo "$1;"
	echo "$1;" | $MYSQL_HOME/bin/mysql $DBNAME
	if [ "$?" -ne 0 ] ; then
		echo "Error executing query: [$1]" >&2
		exit 1
	fi
}


run_query_file_()
{
	if [ ! -f "$1" ] ; then
		echo "Missing argument for run_query_file_()" >&2
		exit 1
	fi
	
	echo "$MYSQL_HOME/bin/mysql $DBNAME < $1"
	$MYSQL_HOME/bin/mysql $DBNAME < $1
	if [ "$?" -ne 0 ] ; then
		echo "Error executing queries from file: [$1]" >&2
		exit 1
	fi
}


check_new_fields_()
{
	_cnf_filename="$1"
	shift
	badList=""
	for f in $@ ; do
		res=`echo "select COLID from Dcfields where COLID='$f';" | $MYSQL_HOME/bin/mysql -N $DBNAME`
		if [ "$?" -ne 0 ] ; then
			echo "Error executing select query on field $f" >&2
			exit 1
		fi
		
		[ -z "$res" ] && continue
		badList="$badList $f"
	done

	if [ -n "$badList" ] ; then
		echo "The following field ID(s) in $_cnf_filename can not be used (already used by eRAD)" >&2
		for f in $badList; do 
			echo "    $f"
		done
		exit 1
	fi
}


run_query_file_	$SQLDIR/$TABLESTBL.ysql
run_query_file_ $SQLDIR/$FIELDSTBL.ysql
run_query_file_ $SQLDIR/$TYPESTBL.ysql
run_query_file_ $SQLDIR/$FLDNDXTBL.ysql


for file in $SQLDIR/*-Dcfields.ysql ; do
	newFields=`awk -vFS="," '/^INSERT/ {print $2}' $file | sed "s;';;g"`
	check_new_fields_ "$file" "$newFields"
done

for file in $SQLDIR/*-*.ysql ; do
	echo "$file"
	run_query_file_ $file
done


#TABLES=`grep -v "^#" $SQLDIR/*-tables`

#echo "Done."

