#!/bin/sh
#
# Component:
#
# Description:
#
# Usage: Has no parameters. The script tests the integrity of the STUDY records, that were modified yesterday.
#
# Last Updated     : $Author$
# Update Date Time : $Date$
# RCS File Name    : $RCSfile$
# RCS Revision     : $Revision$
# Locked by        : $Locker$
# Symbolic name    : $Name$
# State            : $State$
#

. $HOME/etc/setenv.sh

#CURRENTDATE=`date +%Y-%m-%d`
#CHKDIRECTORY=$LOGS_DATED/forever/
#HOSTNAME=`hostname -s`
PREVDATE=`date +%Y-%m-%d -d "-1 day"`

taskLimit="2000"

taskCnt=`ls -R1a $TASKD_GLOBALQUEUE | wc -l`

if [ "$taskLimit" -lt "$taskCnt" ] ; then
	echo "Number of tasks in the queues exceeds $taskLimit limit [$taskCnt]" >> $LOG/checkStudy.log
	exit
fi


#if the log format returned by viewlog.sh changes, this script will presumably not work!!!!!

$LOG_HOME/viewlog.sh -s $PREVDATE -e $PREVDATE | awk '($8 == "STUDY") {print $12}' | sort | sort -u | \
while read studyID; do
	echo `date "+%Y/%m/%d %H:%M:%S"` " Checking $studyID" >> $LOG/checkStudy.log
	$TASKD_HOME/runjavacmd -c "0 imagemed.checkintegrity.CheckStudy -s $studyID -l $LOG/$studyID.log" -p $JAVA_SERVER_PORT
	if [ $? -eq 0 ] ; then
		echo "OK $studyID" >> $LOG/checkStudy.log
	else
		echo "ERROR $studyID" >> $LOG/checkStudy.log
		grep -v "^RESULT:" $LOG/$studyID.log >> $LOG/checkStudy.log
	fi
	rm -f $LOG/$studyID.log
done
