#!/bin/sh
#
# Queries Insite archives for object UIDs of a given study.
#

. $HOME/etc/setenv.sh

. $ARCHIVE_VAR/archive.cfg

if [ "$Archive" != "external" -o -z "$ExternalRetrieve" ] ; then
	echo "External archive is not configured"
	exit
fi

study="$1"
if [ -z "$study" ] ; then
	echo "Mising argument: study instance UID"
	exit
fi

dumpfile="$TMP/insiteQuery.$$.dmp"
queryfile="$TMP/insiteQuery.$$.dcm"


#dump fajlba mentjuk a kovetkezoket
cat << EndOfDumpfile > $dumpfile
  (0008,0052) CS [IMAGE]
  (0020,000d) UI [$study]
  (0008,0018) UI []
EndOfDumpfile


#dicom fajlt csinalunk belole
$DCMTK_HOME/bin/dump2dcm $dumpfile $queryfile
if [ $? -ne 0 ] ; then
	echo "Dump2dcm error"
	exit
fi
  
# QUERY="select HOST,PORT,TYPE,AE,PROTOCOL from $TARGETTBL where ID='$ExternalRetrieve'"
# SQL_RES=`echo "$QUERY;" | $MYSQL_HOME/bin/mysql -E $DBNAME 2>/dev/null`
# 
# if [ $? -ne 0 ] ; then
# 	echo "MySQL error"
# 	exit
# fi
# 
# # This line below will create FWD_<DNAME>="<VALUE>" equations and
# # evaluate them, so eg.: $FWD_HOST and FWD_AE can be used in later codes
# eval `echo "$SQL_RES" | grep -v "^\*\*" | sed -e 's/ */QR_/' -e 's/: /="/' -e 's/$/"/'`
# 
# if [ -z "$QR_HOST" -o -z "$QR_PORT" -o -z "$QR_TYPE" -o -z "$QR_AE" -o -z "$QR_PROTOCOL" ] ; then
# 	echo "Bad host entry in Target table for $ExternalRetrieve"
# 	exit
# fi
# 
# . $DICOM_VAR/pb-scp.cfg
# [ -z "$AE_TITLE" ] && AE_TITLE="$DICOM_AE_TITLE"
# 
# TLS_OPT=""
# [ "$QR_PROTOCOL" = "S" ] && TLS_OPT="+tls $SSL_SITE_KEY $SSL_SITE_CERT -ic +ps"
# 
# echo $DICOM_HOME/bin/findscu -v -S $TLS_OPT --aetitle "$AE_TITLE" --call "$QR_AE" $QR_HOST $QR_PORT $queryfile
# 
# if [ "$fQR_PROTOCOL" = "S" ] ; then
# 	$OPENSSL_PASS
# fi | \
# 
# RES=`$DICOM_HOME/bin/findscu -S $TLS_OPT --aetitle "$AE_TITLE" --call "$QR_AE" $QR_HOST $QR_PORT $queryfile`
# if [ $? -ne 0 ] ; then
# 	echo "Error querying insite archive"
# 	exit
# fi
# 
# echo "RES: [$RES]"
# 
# 
# SOPInstances=`grep "^(0008,0018)" <<<"$RES"`
# 
# #SOPInstances=`sed 's;^(0008,0018).*\[\(.*\)\].*$;\1;p' <<<"$RES"`
# #SOPInstances=`sed -n 's;^(0008,0018).*\[\(.*\)\].*$;\1;p' <<<"$RES"`
# 
# echo "$SOPInstances"

RESULT=`$QR_HOME/find.sh -S -h "$ExternalRetrieve" -f $dumpfile`
if [ $? -ne 0 ] ;then
	echo "find.sh error"
	exit
fi

# echo "RESULT: [$RESULT]"

SOPInstances=`sed -n 's;^(0008,0018).*\[\(.*\)\].*$;\1;p' <<<"$RESULT"`

echo "$SOPInstances"

# rm $dumpfile
# rm $queryfile


