#!/bin/sh
#
# Component: iface
#
# Description:
#     Wrapper around bin/processorder 
#
# Usage:
#     processedit.sh [-n] -f <modfile> [-u <userid>] [-d <device>]
#
# For more information on usage see $IFACE_HOME/bin/processorder
#
# Last Updated     : $Author$
# Update Date Time : $Date$
# RCS File Name    : $RCSfile$
# RCS Revision     : $Revision$
# Locked by        : $Locker$
# Symbolic name    : $Name$
# State            : $State$
#

. $HOME/etc/setenv.sh


File=""
User=""
Device=""
CheckValidOrder=""
CreateNewOrder=""

while getopts 'ncf:u:d:' OPT; do
	case $OPT in
	n) CheckValidOrder="-n" ;;
	c) CreateNewOrder="-c" ;;
	f) File="$OPTARG" ;;
	u) User="-u \"$OPTARG\"" ;;
	d) Device="-d \"$OPTARG\"" ;;
	*) ERRMSG="Invalid_Parameter:$OPT" ;;
	esac
done


if [ -z "$File" ] ; then
	# old style arguments for backward compatibility

	if [ "$1" = "-n" ] ; then
	CheckValidOrder="-n"
	shift
	fi

	File=$1
	User=$2
	[ -n "$User" ] && User=" -u \"$User\""
fi

[ -z "$File" -o ! -f "$File" ] && exit 1;

Date=`date +"%Y%m%d%H%M%S"`

OrderFile=$TMP/procorder.$Date.$$

$DCVIEWER_HOME/dcmod -c -f $File $OrderFile

[ $? -ne 0 ] && exit 1

PO_COMMAND="$SR_HOME/bin/processorder $CreateNewOrder $CheckValidOrder -f $OrderFile $User $Device"

# echo $PO_COMMAND > $TMP/procorder.cmd.$$
eval $PO_COMMAND

Res=$?

rm $OrderFile 2>/dev/null

exit $Res
